﻿using System.Diagnostics;

namespace MemoryLeakTest
{
	using System;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Threading;

	public class TestModel : INotifyPropertyChanged
	{
		private readonly DispatcherTimer timer;
		private int count;

		public event PropertyChangedEventHandler PropertyChanged = delegate { };

		public TestModel()
		{
			timer = new DispatcherTimer(DispatcherPriority.Normal)
						{
							Interval = TimeSpan.FromMilliseconds(50)
						};
			timer.Tick += Timer_Tick;
			timer.Start();
		}

		public IEnumerable Data
		{
			get
			{
				return new[]
				{
					new {Name = "Ayende"},
				};
			}
		}

		private void Timer_Tick(object sender, EventArgs e)
		{
			if (count++ % 100 == 0)
			{
				GC.Collect(2, GCCollectionMode.Forced);
				Console.WriteLine("{0:#,#}", Process.GetCurrentProcess().WorkingSet64);
			}
			PropertyChanged(this, new PropertyChangedEventArgs("Data"));
		}
	}
}